package lbedogni.unibo.cs.it.downloaderexamples;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.JsonReader;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.android.volley.RequestQueue;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.squareup.okhttp.Callback;
import com.squareup.okhttp.OkHttpClient;
import com.squareup.okhttp.Request;
import com.squareup.okhttp.Response;

import java.io.IOException;
import java.io.StringReader;

public class Downloaders extends AppCompatActivity implements View.OnClickListener {

    Button btnOk;
    Button btnVolley;

    private static TextView tvOk;
    private static TextView tvVolley;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_downloaders);
        btnOk = (Button)findViewById(R.id.btnOk);
        btnVolley = (Button)findViewById(R.id.btnVolley);
        btnOk.setOnClickListener(this);
        btnVolley.setOnClickListener(this);

        tvOk = (TextView)findViewById(R.id.tvOk);
        tvVolley = (TextView)findViewById(R.id.tvVolley);
    }

    @Override
    protected void onResume() {
        super.onResume();

    }

    private static String getWeather(JsonReader reader) {
        try {
            reader.beginObject();
            while (reader.hasNext()) {

                String name = reader.nextName();
                Log.v("NAME",name);
                if (name.equals("weather")) {
                    reader.beginArray();
                    reader.beginObject();
                    while (reader.hasNext()) {
                        name = reader.nextName();
                        Log.v("NAME",name);
                        if (name.equals("main")) {
                            return reader.nextString();
                        } else {
                            reader.skipValue();
                        }
                    }
                } else {
                    reader.skipValue();
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return "Not available";
    }


    @Override
    public void onClick(View view) {
        String baseUrl = "http://api.openweathermap.org/data/2.5/weather?q=" +
                "Bologna,it&appid=dbb053f754d76daf2c503721cf040e4e";
        if (view == btnOk) {
            OkHttpClient client = new OkHttpClient();

            Request request = new Request.Builder()
                    .url(baseUrl)
                    .build();
            client.newCall(request).enqueue(new Callback() {
                @Override
                public void onFailure(Request request, IOException e) {

                }

                @Override
                public void onResponse(final Response response) throws IOException {
                    Downloaders.this.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            JsonReader jr = null;
                            try {
                                jr = new JsonReader(new StringReader(response.body().string()));
                                jr.setLenient(true);
                                tvOk.setText(getWeather(jr));
                            } catch (IOException e) {
                                e.printStackTrace();
                            }

                        }
                    });
                }
            });
        } else if (view == btnVolley) {
            RequestQueue queue = Volley.newRequestQueue(this);
            // Request a string response from the provided URL.
            StringRequest stringRequest = new StringRequest(com.android.volley.Request.Method.GET, baseUrl,
                    new com.android.volley.Response.Listener<String>() {
                        @Override
                        public void onResponse(String response) {
                            JsonReader jr = new JsonReader(new StringReader(response.toString()));
                            // Display the first 500 characters of the response string.
                            tvVolley.setText(getWeather(jr));

                        }
                    }, new com.android.volley.Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {
                    tvVolley.setText("Not Available");
                }
            });
// Add the request to the RequestQueue.
            queue.add(stringRequest);

        }
    }
}
